local AceGUI = LibStub("AceGUI-3.0")

function DEDKP_ImportWindow_Show()
	DERR.ImportWindow = AceGUI:Create("Frame")
	DERR.ImportWindow:SetTitle("Draconis Erus Points Import")
	DERR.ImportWindow:SetLayout("Flow")
	DERR.ImportWindow:SetWidth(410)
	DERR.ImportWindow:SetHeight(210)
	DERR.ImportWindow:EnableResize(false)
	DERR.ImportWindow:SetCallback("OnClose", DEDKP_ImportWindow_OnClose)

	DERR.ImportWindow.Link = AceGUI:Create("InteractiveLabel")
	DERR.ImportWindow.Link:SetFullWidth(true)
	DERR.ImportWindow.Link:SetText("Import data from https://www.draconiserus.com")
	DERR.ImportWindow.Link:SetCallback("OnClick", DEDKP_ImportWindow_Link_OnClick)
	DERR.ImportWindow:AddChild(DERR.ImportWindow.Link)

	DERR.ImportWindow.ImportBox = AceGUI:Create("MultiLineEditBox")
	DERR.ImportWindow.ImportBox:SetFullHeight(true)
	DERR.ImportWindow.ImportBox:SetFullWidth(true)
	DERR.ImportWindow.ImportBox:SetLabel(" ")
	DERR.ImportWindow.ImportBox:SetNumLines(10)
	DERR.ImportWindow.ImportBox:SetCallback("OnEnterPressed",DEDKP_ImportWindow_ImportBox_OnEnterPressed)
	DERR.ImportWindow:AddChild(DERR.ImportWindow.ImportBox)

	DraconisErus_SetWindowPosition("ImportWindow", DERR.ImportWindow)

end

function DEDKP_ImportWindow_Link_OnClick()
	StaticPopupDialogs["SHOW_EXPORT"] = StaticPopupDialogs["SHOW_EXPORT"] or {
	text = "Draconis Erus Export",
	button2 = ACCEPT,
	hasEditBox = 1,
	hasWideEditBox = 1,
	editBoxWidth = 350,

	preferredIndex = 3,

	OnShow = function(this, ...)
		this:SetWidth(420)

		local editBox = _G[this:GetName() .. "WideEditBox"] or _G[this:GetName() .. "EditBox"]

		editBox:SetText(StaticPopupDialogs["SHOW_EXPORT"].urltext)
		editBox:SetFocus()
		editBox:HighlightText(false)

		local button = _G[this:GetName() .. "Button2"]
		button:ClearAllPoints()
		button:SetWidth(200)
		button:SetPoint("CENTER", editBox, "CENTER", 0, -30)
	end,
	OnHide = NOP,
	OnAccept = NOP,
	OnCancel = NOP,
	EditBoxOnEscapePressed = function(this, ...) this:GetParent():Hide() end,
	timeout = 0,
	whileDead = 1,
	hideOnEscape = 1
	}

	local link = "https://www.draconiserus.com/viewforum.php?f=23"
	StaticPopupDialogs["SHOW_EXPORT"].urltext = link
	StaticPopup_Show("SHOW_EXPORT", link)
end

function DEDKP_ImportWindow_ImportBox_OnEnterPressed(self)
	local tbl = { strsplit(",",self:GetText()) }
	local tmpPoints = {}
	local import = true
	if table.getn(tbl) > 0 then
		for index, value in pairs(tbl) do
			local name, points = strsplit(":",value)
			if name == "!VERSION" then
				tmpPoints[name] = tonumber(points)
			elseif DraconisErus_Guild_HasPlayer(name) then
				tmpPoints[name] = tonumber(points)
			end
		end

		local lastImport = DEDKPSettings["LastImport"]
		if lastImport == nil then lastImport = "1" end
		if tonumber(lastImport) > tonumber(tmpPoints["!VERSION"]) then
			DERR.ImportWindow:SetStatusText("|cFFFF0000Your current points are newer.|r")
			import = false
		else
			DEDKPPoints[DERR_REALM][DERR_GUILD] = DraconisErus_Guild_GetEmptyPoints()
			for index, _ in pairs(tmpPoints) do
				DEDKPPoints[DERR_REALM][DERR_GUILD][index] = tmpPoints[index]
			end
		end
		if DERR.MainWindow ~= nil then DEDKP_MainWindow_LoadGuild() end
		if import then DEDKP_ImportWindow_OnClose(DERR.ImportWindow) end
		if 	DraconisErus_PlayerAuth(1,0,0) then
 			DraconisErus_Comm_Send("DERRGETDKP",DEDKPPoints[DERR_REALM][DERR_GUILD],"GUILD")
		end
	end
end

function DEDKP_ImportWindow_OnClose(widget)
	if DERR.ImportWindow ~= nil then
		DraconisErus_SaveWindowPosition("ImportWindow", widget)
		widget:ReleaseChildren()
		widget:Hide()
		DERR.ImportWindow = nil
	end
end